<nav class="navbar navbar-expand-lg  bg-dark">
  <div class="col-md-2 text-center">
    <a class="navbar-brand" href="" >PIC SIMULATOR</a>
  </div>
  <div class="col-md-10">
    <div class="collapse navbar-collapse" id="navbarText">
      <ul class="navbar-nav mr-auto">
        <li class="nav-item "><a class="nav-link " routerLink="/editor">Editor</a></li>
        <li class="nav-item active"><a class="nav-link" routerLink="/simulator">Simulator</a></li>
      </ul>
    </div>
  </div>
</nav>
<div class="row">
  <div class="col-md-5">
    <div class="col-md-12 col-lg-12">
      <div class="row">
        <div class="col-md-12 col-lg-12 segundo">
          <br>
          <div class="form-group row text-center" >
            <label for="" class="col-md-1 col-form-label">.SIM:</label>
            <div class="col-md-3"><input type="text" class="form-control" id="formGroupExampleInput"  disabled></div>
            <label for="" class="col-md-1 col-form-label">Microcontroller:</label>
            <div class="col-md-2">
              <input type="text" class="form-control" id="formGroupExampleInput" value={{cycleExecutionDetails.microcontrollerModel}} disabled>
            </div>
            <label for="" class="col-md-1 col-form-label">Clock:</label>
            <div class="col-md-2">
              <input type="text" class="form-control" id="formGroupExampleInput" placeholder="Example input" disabled>
            </div>
            <label style="margin-top: 10px">Hz.</label>
            <br>
          </div>
          <hr style="border-color:#263238">
          <div class="form-group row text-center">
            <label for="" class="col-md-2 col-form-label">Program Counter:</label>
            <div class="col-md-3"><input type="text" class="form-control" id="formGroupExampleInput" value={{cycleExecutionDetails.programCounter}} disabled></div>
            <label for="" class="col-md-1 col-form-label">Current Instruction:</label>
            <div class="col-md-2"><input type="text" class="form-control" id="formGroupExampleInput" value={{cycleExecutionDetails.currentInstruction}} disabled></div>
            <label for="" class="col-md-2 col-form-label">Total CLK Cycles:</label>
            <div class="col-md-2"><input type="text" class="form-control" id="formGroupExampleInput" value={{cycleExecutionDetails.totalCycles}} disabled></div>
            <br>
          </div>
          <div class="form-group row text-center">
            <label for="" class="col-md-2 col-form-label">Instructions Executed:</label>
            <div class="col-md-3"><input type="text" class="form-control" id="formGroupExampleInput" placeholder="Example input" disabled></div>
            <label for="" class="col-md-1 col-form-label">Next Instruction:</label>
            <div class="col-md-2" style="margin-left: 18px"><input type="text" class="form-control" id="formGroupExampleInput" value={{cycleExecutionDetails.nextInstruction}} disabled></div>
            <label for="" class="col-md-2 col-form-label" style="margin-left: -18px">Us Elapsed:</label>
            <div class="col-md-2"><input type="text" class="form-control" id="formGroupExampleInput" value="0" disabled></div>
            <br>
          </div>
        </div>
      </div>
      <br>
      <br>
      <br>
      <br>
      <br>
      <br>
      <div class="row">
        <div class="col-md-3"></div>
        <div class="col-md-1">
            <div class="row">_<button id="portA2" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[2])}">RA2</button></div>
            <div class="row">_<button id="portA3" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[3])}">RA3</button></div>
            <div class="row">_<button id="portA4" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[4])}">RA4</button></div>
            <div class="row">_<button id="" class="btn btn-sm btn-block" [ngStyle]="{'background': '#FFFFFF'}">MCLR</button></div>
            <div class="row">_<button id="" class="btn btn-sm btn-block" [ngStyle]="{'background': '#FFFFFF'}">VSS</button></div>
            <div class="row">_<button id="portb0" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[0])}">RB0</button></div>
            <div class="row">_<button id="portb1" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[1])}">RB1</button></div>
            <div class="row">_<button id="portb2" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[2])}">RB2</button></div>
            <div class="row">_<button id="portb3" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[3])}">RB3</button></div>
        </div>
        <div class="col-md-4 text-center">
          <div><img src="../assets/img/16f84.png" class="img-fluid"></div>
        </div>
        <div class="col-md-1 text-left">
            <div class="row">_<button id="portA1" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[1])}">RA1</button></div>
            <div class="row">_<button id="portA0" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[0])}">RA0</button></div>
            <div class="row">_<button id="" class="btn btn-sm btn-block" [ngStyle]="{'background': '#FFFFFF'}">OSC1</button></div>
            <div class="row">_<button id="" class="btn btn-sm btn-block" [ngStyle]="{'background': '#FFFFFF'}">OSC2</button></div>
            <div class="row">_<button id="" class="btn btn-sm btn-block" [ngStyle]="{'background': '#FFFFFF'}">VDD</button></div>
            <div class="row">_<button id="portb7" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[7])}">RB7</button></div>
            <div class="row">_<button id="portb6" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[6])}">RB6</button></div>
            <div class="row">_<button id="portb5" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[5])}">RB5</button></div>
            <div class="row">_<button id="portb4" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[4])}">RB4</button></div>
        </div>
        <div class="col-md-3"></div>
      </div>
    </div>
  </div>

  <div class="col-md-7">
    <div class="container-fluid segundo" >
      <div class="col-md-12 text-center" style="margin-bottom: 10px"><label class="h4">Interaction With RAM Addresses</label></div>
        <div class="row">
          <div class="col-md-6">
            <div class="col-md-12 text-center" style="margin-top: 10px;margin-bottom: 10px"><label class="h5">Read Ram Address</label></div>
            <div>
              <table class="table  table-sm" style="border:0">
                <thead class="text-center">
                  <tr>
                    <th scope="col" style="width: 150px">Address</th>
                    <th></th>
                    <th scope="col">7</th>
                    <th scope="col">6</th>
                    <th scope="col">5</th>
                    <th scope="col">4</th>
                    <th scope="col">3</th>
                    <th scope="col">2</th>
                    <th scope="col">1</th>
                    <th scope="col">0</th>
                  </tr>
                </thead>
                <tbody class="text-center">
                  <tr>
                    <td class="text-center"><button class="btn btn-info btn-block" type="button" (click)="showRamRegister()">Get Register</button></td>
                    <td ><input type="text" name="input-text" class="form-control" [(ngModel)]="getMemoryRegisterAddress"></td>
                    <td colspan="1" ><button id="getRegisterValueBit7" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[7])}" (click)="toggleState('getRegValue', '7')">{{getRegisterValue[7]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit6" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[6])}" (click)="toggleState('getRegValue', '6')">{{getRegisterValue[6]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit5" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[5])}" (click)="toggleState('getRegValue', '5')">{{getRegisterValue[5]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit4" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[4])}" (click)="toggleState('getRegValue', '4')">{{getRegisterValue[4]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit3" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[3])}" (click)="toggleState('getRegValue', '3')">{{getRegisterValue[3]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit2" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[2])}" (click)="toggleState('getRegValue', '2')">{{getRegisterValue[2]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit1" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[1])}" (click)="toggleState('getRegValue', '1')">{{getRegisterValue[1]}}</button></td>
                    <td colspan="1" ><button id="getRegisterValueBit0" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(getRegisterValue[0])}" (click)="toggleState('getRegValue', '0')">{{getRegisterValue[0]}}</button></td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>

          <div class="col-md-6">
            <div class="col-md-12 text-center" style="margin-top: 10px;margin-bottom: 10px"><label class="h5">Write Ram Address</label></div>
            <div>
              <table class="table  table-sm text-center" >
                <thead>
                  <tr>
                    <th scope="col" style="width: 150px">Address</th>
                    <th></th>
                    <th scope="col">7</th>
                    <th scope="col">6</th>
                    <th scope="col">5</th>
                    <th scope="col">4</th>
                    <th scope="col">3</th>
                    <th scope="col">2</th>
                    <th scope="col">1</th>
                    <th scope="col">0</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td class="text-center"><button class="btn btn-info btn-block" type="button" (click)="setRamRegister()">Set Register</button></td>
                    <td ><input class="form-control input-sm" type="text" name="" id="12" [(ngModel)]="setMemoryRegisterAddress"></td>
                    <td colspan="1" ><button id="setRegisterValueBit7" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[7])}" (click)="toggleState('setRegValue', '7')">{{setRegisterValue[7]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit6" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[6])}" (click)="toggleState('setRegValue', '6')">{{setRegisterValue[6]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit5" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[5])}" (click)="toggleState('setRegValue', '5')">{{setRegisterValue[5]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit4" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[4])}" (click)="toggleState('setRegValue', '4')">{{setRegisterValue[4]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit3" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[3])}" (click)="toggleState('setRegValue', '3')">{{setRegisterValue[3]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit2" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[2])}" (click)="toggleState('setRegValue', '2')">{{setRegisterValue[2]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit1" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[1])}" (click)="toggleState('setRegValue', '1')">{{setRegisterValue[1]}}</button></td>
                    <td colspan="1" ><button id="setRegisterValueBit0" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(setRegisterValue[0])}" (click)="toggleState('setRegValue', '0')">{{setRegisterValue[0]}}</button></td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
    </div>

    <div class="container-fluid segundo">
      <div class="col-sm-12 text-center" style="margin-top: 10px;margin-bottom: 10px"><label class="h4">Interaction With Ports</label></div>
      <div class="row">
        <div class="col-sm-6">
          <table class="table text-center table-sm" >
            <thead>
              <tr>
                <th scope="col" style="width: 150px"></th>
                <th scope="col">7</th>
                <th scope="col">6</th>
                <th scope="col">5</th>
                <th scope="col">4</th>
                <th scope="col">3</th>
                <th scope="col">2</th>
                <th scope="col">1</th>
                <th scope="col">0</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td class="text-center"><button class="btn btn-info btn-block" type="button" (click)="setPortA()">Set PORT A</button></td>
                <td colspan="1" ><button id="portA7" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[7])}" (click)="toggleState('portA', '7')">{{portA[7]}}</button></td>
                <td colspan="1" ><button id="portA6" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[6])}" (click)="toggleState('portA', '6')">{{portA[6]}}</button></td>
                <td colspan="1" ><button id="portA5" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[5])}" (click)="toggleState('portA', '5')">{{portA[5]}}</button></td>
                <td colspan="1" ><button id="portA4" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[4])}" (click)="toggleState('portA', '4')">{{portA[4]}}</button></td>
                <td colspan="1" ><button id="portA3" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[3])}" (click)="toggleState('portA', '3')">{{portA[3]}}</button></td>
                <td colspan="1" ><button id="portA2" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[2])}" (click)="toggleState('portA', '2')">{{portA[2]}}</button></td>
                <td colspan="1" ><button id="portA1" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[1])}" (click)="toggleState('portA', '1')">{{portA[1]}}</button></td>
                <td colspan="1" ><button id="portA0" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portA[0])}" (click)="toggleState('portA', '0')">{{portA[0]}}</button></td>
              </tr>
            </tbody>
          </table>
        </div>
        <div class="col-sm-6">
          <table class="table  table-sm text-center" >
            <thead>
              <tr>
                <th scope="col" style="width: 150px"></th>
                <th scope="col">7</th>
                <th scope="col">6</th>
                <th scope="col">5</th>
                <th scope="col">4</th>
                <th scope="col">3</th>
                <th scope="col">2</th>
                <th scope="col">1</th>
                <th scope="col">0</th>
              </tr>
            </thead>
            <tbody>
              <tr>
                <td class="text-center"><button class="btn btn-info btn-block" type="button" (click)="setPortB()">Set PORT B</button></td>
                <td colspan="1" ><button id="portB7" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[7])}" (click)="toggleState('portB', '7')">{{portB[7]}}</button></td>
                <td colspan="1" ><button id="portB6" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[6])}" (click)="toggleState('portB', '6')">{{portB[6]}}</button></td>
                <td colspan="1" ><button id="portB5" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[5])}" (click)="toggleState('portB', '5')">{{portB[5]}}</button></td>
                <td colspan="1" ><button id="portB4" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[4])}" (click)="toggleState('portB', '4')">{{portB[4]}}</button></td>
                <td colspan="1" ><button id="portB3" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[3])}" (click)="toggleState('portB', '3')">{{portB[3]}}</button></td>
                <td colspan="1" ><button id="portB2" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[2])}" (click)="toggleState('portB', '2')">{{portB[2]}}</button></td>
                <td colspan="1" ><button id="portB1" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[1])}" (click)="toggleState('portB', '1')">{{portB[1]}}</button></td>
                <td colspan="1" ><button id="portB0" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(portB[0])}" (click)="toggleState('portB', '0')">{{portB[0]}}</button></td>
              </tr>
            </tbody>
          </table>
        </div>
      </div>
    </div>
    <div class="container-fluid segundo">
      <div class="row">
        <div class=" col-sm-6 container-fluid segundo">
          <div class="row">
            <div class="col-sm-12 text-center" style="margin-top: 10px;margin-bottom: 10px"><label class="h5">W Register</label></div>
            <div class="col-sm-12">
              <table class="table  table-sm text-center" >
                <thead>
                  <tr>
                    <th scope="col" >7</th>
                    <th scope="col">6</th>
                    <th scope="col">5</th>
                    <th scope="col">4</th>
                    <th scope="col">3</th>
                    <th scope="col">2</th>
                    <th scope="col">1</th>
                    <th scope="col">0</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[7])}" (click)="toggleState('workingRegister', '7')" >{{workingRegister[7]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[6])}" (click)="toggleState('workingRegister', '6')" >{{workingRegister[6]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[5])}" (click)="toggleState('workingRegister', '5')" >{{workingRegister[5]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[4])}" (click)="toggleState('workingRegister', '4')" >{{workingRegister[4]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[3])}" (click)="toggleState('workingRegister', '3')" >{{workingRegister[3]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[2])}" (click)="toggleState('workingRegister', '2')" >{{workingRegister[2]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[1])}" (click)="toggleState('workingRegister', '1')" >{{workingRegister[1]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(workingRegister[0])}" (click)="toggleState('workingRegister', '0')" >{{workingRegister[0]}}</button></td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
        <div class="col-sm-6 container-fluid segundo">
          <div class="row">
            <div class="col-sm-12 text-center" style="margin-top: 10px;margin-bottom: 10px"><label class="h5">Status Register</label></div>
            <div class="col-sm-12">
              <table class="table  table-sm text-center" >
                <thead>
                  <tr>
                    <th scope="col">IRP</th>
                    <th scope="col">RP1</th>
                    <th scope="col">RP0</th>
                    <th scope="col">TO</th>
                    <th scope="col">PD</th>
                    <th scope="col">Z</th>
                    <th scope="col">DC</th>
                    <th scope="col">C</th>
                  </tr>
                </thead>
                <tbody>
                  <tr>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[7])}" (click)="toggleState('statusRegister', '7')" >{{statusRegister[7]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[6])}" (click)="toggleState('statusRegister', '6')" >{{statusRegister[6]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[5])}" (click)="toggleState('statusRegister', '5')" >{{statusRegister[5]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[4])}" (click)="toggleState('statusRegister', '4')" >{{statusRegister[4]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[3])}" (click)="toggleState('statusRegister', '3')" >{{statusRegister[3]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[2])}" (click)="toggleState('statusRegister', '2')" >{{statusRegister[2]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[1])}" (click)="toggleState('statusRegister', '1')" >{{statusRegister[1]}}</button></td>
                    <td colspan="1" ><button id="" class="btn btn-sm btn-block" [ngStyle]="{'background':setBoxColor(statusRegister[0])}" (click)="toggleState('statusRegister', '0')" >{{statusRegister[0]}}</button></td>
                  </tr>
                </tbody>
              </table>
            </div>
          </div>
        </div>
      </div>
    </div>

    <div class="col-md-12 col-lg-12 fondo container-fluid">
      <div class="row">
        <div class="col-md-5 col-lg-5 text" style="margin-top: 10px">
          <div class="col-lg-12 col-md-12 text-center"><label class="h4" style="margin-bottom: 20px">Spec Function Registers (SFR)</label></div>
          <div class="table-wrapper-2">
            <table class="table text-center table-bordered table-sm" >
              <thead>
                <tr>
                  <th scope="col">(Addr.)</th>
                  <th scope="col">Name</th>
                  <th scope="col">Hex</th>
                  <th scope="col">7</th>
                  <th scope="col">6</th>
                  <th scope="col">5</th>
                  <th scope="col">4</th>
                  <th scope="col">3</th>
                  <th scope="col">2</th>
                  <th scope="col">1</th>
                  <th scope="col">0</th>
                </tr>
              </thead>
              <tbody *ngIf="showRegisters">
                <tr *ngFor="let register of specialPurposeRegisters" >
                  <td >{{register.address}}</td>
                  <td >{{register.name}}</td>
                  <td >{{register.hexValue}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit7)}">{{register.bit7}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit6)}">{{register.bit6}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit5)}">{{register.bit5}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit4)}">{{register.bit4}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit3)}">{{register.bit3}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit2)}">{{register.bit2}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit1)}">{{register.bit1}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit0)}">{{register.bit0}}</td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
        <div class="col-md-2 col-lg-2 text-center" >
          <div class="btn-group-vertical btn-group-md" role="group" aria-label="Basic example" style="margin-top: 80px">
            <button type="button" class="btn bg-light"><input type="file" name="file" id="file" accept=".sim" class="inputfile" (change)="fileUpload($event)"/><label for="file"><img width="32" height="32" src="../assets/img/file.png" ></label></button>
            <button type="button" class="btn bg-light"><img src="../assets/img/burn.png" (click)="burnFlash()"></button>
            <!-- <button type="button" class="btn bg-light"><img src="../assets/img/back.png"></button> -->
            <button type="button" class="btn  bg-light"><img src="../assets/img/play.png" (click)="run()"></button>
            <button type="button" class="btn  bg-light"><img src="../assets/img/step.png" (click)="runBySteps()"></button>
            <button type="button" class="btn  bg-light"><img src="../assets/img/pause.png" (click)="tooglePause()"></button>
            <button type="button" class="btn  bg-light"><img src="../assets/img/time.png" (click)="reset()"></button>
            <button type="button" class="btn  bg-light"><img src="../assets/img/search.png" (click)="getRam()"></button>
            <button class="btn btn-outline-primary mb-2 mr-2" (click)="openVerticallyCentered(content)" (click)="showFlash()">show Flash</button>
          </div>
        </div>
        <div class="col-md-5 col-lg-5 text" style="margin-top: 10px">
          <div class="col-lg-12 col-md-12 text-center fondo"><label class="h4" style="margin-bottom: 20px">Gral Purpose Registers (GPR)</label></div>
          <div class="table-wrapper-2">
            <table class="table text-center table-bordered table-sm" >
              <thead>
                <tr>
                  <th scope="col" >Address</th>
                  <th scope="col">Hex</th>
                  <th scope="col">7</th>
                  <th scope="col">6</th>
                  <th scope="col">5</th>
                  <th scope="col">4</th>
                  <th scope="col">3</th>
                  <th scope="col">2</th>
                  <th scope="col">1</th>
                  <th scope="col">0</th>
                </tr>
              </thead>
              <tbody *ngIf="showRegisters">
                <tr *ngFor="let register of gralPurposeRegisters" >
                  <td >{{register.address}}</td>
                  <td >{{register.hexValue}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit7)}">{{register.bit7}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit6)}">{{register.bit6}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit5)}">{{register.bit5}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit4)}">{{register.bit4}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit3)}">{{register.bit3}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit2)}">{{register.bit2}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit1)}">{{register.bit1}}</td>
                  <td colspan="1"  [ngStyle]="{'background':getColor(register.bit0)}">{{register.bit0}}</td>
                </tr>
              </tbody>
            </table>
          </div>
        </div>
      </div>
    </div>
  </div>
</div>

<ng-template #content let-close="close" let-dismiss="dismiss">
  <div class="modal-header">
    <h4 class="modal-title">Flash Memory</h4>
    <button type="button" class="close" aria-label="Close" (click)="dismiss('Cross click')">
      <span aria-hidden="true">&times;</span>
    </button>
  </div>
  <div class="modal-body">
    <div class="table-wrapper-2">
      <table class="table text-center table-bordered table-sm" >
        <thead>
          <tr>
            <th scope="col" >Address</th>
            <th scope="col">Hex</th>
            <!-- <th scope="col">14</th> -->
            <th scope="col">13</th>
            <th scope="col">12</th>
            <th scope="col">11</th>
            <th scope="col">10</th>
            <th scope="col">9</th>
            <th scope="col">8</th>
            <th scope="col">7</th>
            <th scope="col">6</th>
            <th scope="col">5</th>
            <th scope="col">4</th>
            <th scope="col">3</th>
            <th scope="col">2</th>
            <th scope="col">1</th>
            <th scope="col">0</th>
          </tr>
        </thead>
        <tbody>
            <tr *ngFor="let register of flashRegisters" >
            <td >{{register.address}}</td>
            <td >{{register.hexValue}}</td>
            <!-- <td colspan="1"  [ngStyle]="{'background':getColor(register.bit14)}">{{register.bit13}}</td> -->
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit13)}">{{register.bit13}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit12)}">{{register.bit12}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit11)}">{{register.bit11}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit10)}">{{register.bit10}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit9)}">{{register.bit9}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit8)}">{{register.bit8}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit7)}">{{register.bit7}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit6)}">{{register.bit6}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit5)}">{{register.bit5}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit4)}">{{register.bit4}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit3)}">{{register.bit3}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit2)}">{{register.bit2}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit1)}">{{register.bit1}}</td>
            <td colspan="1"  [ngStyle]="{'background':getColor(register.bit0)}">{{register.bit0}}</td>
          </tr>
        </tbody>
      </table>
    </div>
  </div>
  <div class="modal-footer">
    <button type="button" class="btn btn-light" (click)="close('Close click')">Close</button>
  </div>
</ng-template>
